#include "../include/rational.hpp"
#include "../include/exponencial.hpp"

CExponencial::CExponencial( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CExponencial::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    CBigInt one(1);
    if (b->m_denominator->cmp(&one)) {
        std::unique_ptr<CRational> tmp (a->ln());
        tmp.reset( tmp->mul(b.get()) );
        return tmp->exp();
    }

    if (b->isNegative()) {
        b->negate();
        auto tmp = new CRational( a->m_denominator->power(b->m_numerator->debugDump()),
                                  a->m_numerator  ->power(b->m_numerator->debugDump()) );
        b->negate();
        return tmp;
    }

    return new CRational( a->m_numerator  ->power(b->m_numerator->debugDump()),
                          a->m_denominator->power(b->m_numerator->debugDump()) );
}