#pragma once
#include "rational.hpp"
#include "operator.hpp"

/**
 * @class CAddition
 * @brief The CAddition class represents the addition operator.
 * It inherits from the COperator class.
 */
class CAddition : public COperator {
public:
    /**
     * @brief Constructor for CAddition class.
     * @param a The first argument of the addition operation.
     * @param b The second argument of the addition operation.
     */
    CAddition( CPrintable *a, CPrintable *b );

    /**
     * @brief Default constructor for CAddition class.
     */
    CAddition() = default;

    /**
     * @brief Destructor for CAddition class.
     */
    ~CAddition() = default;

    /**
     * @brief Evaluates the addition operation.
     * @return A CRational pointer representing the result of the addition.
     */
    virtual CRational *evaluate() override;
private:
};
