#pragma once
#include <memory>
#include <string>

class CRational;

/**
 * @brief The CPrintable class represents an abstract printable object.
 */
class CPrintable {
public:
    /**
     * @brief Default constructor for CPrintable class.
     */
    CPrintable() = default;

    /**
     * @brief Default destructor for CPrintable class.
     */
    virtual ~CPrintable() = default;

    /**
     * @brief Evaluates the printable object.
     * @return A CRational pointer representing the evaluated result.
     */
    virtual CRational *evaluate() = 0;
};
